=== pogs/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for POGS
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

.SUFFIXES:

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUT_NAME:=pogs

# Location of root.
ROOT:=..

################################################################################
# DETERMINE HOST INFORMATION
################################################################################

# Determine which platform this Makefile is being run on.
TARGET:=$(shell uname -s)

# Canonicalize the target string.
ifeq ($(findstring CYGWIN_NT,${TARGET}),CYGWIN_NT)
    TARGET:=Windows
endif

################################################################################
# DYNAMIC DEPENDENCIES
################################################################################

# Every *.ad? file is required, except those excluded below.
# Note that some of these excluded files may not be present due to a make
# clean before building the source distribution. However, they are still
# referenced here to make their exclusion explicit.

# Do not distribute files that must be prepped.
SPARK_PREPED:=oscommandline.adb

################################################################################
# PLATFORM INDEPENDENT CONFIGURATION
################################################################################

# Location of customer lib
CUSTOMER_LIB:=${ROOT}/lib/spark/current

# Location of common.
COMMON:=${ROOT}/common

# Options to submit to gnatprep.
# DEBUG: The Examiner raises a fatal error during self-analysis with
#        Source_Reference pragmas in place. Thus, the handy "-r" option
#        is removed until the error is fixed.
PREP_OPTS:=-c

# Files containing platform specific code that is handled by gnatprep
PREP_TARGETS:=${SPARK_PREPED}

# Common compiler options.
COMMON_OPTS:=-g -gnatwae -gnat05 -gnatwl -gnaty3abefhiklnprt -I${CUSTOMER_LIB} -I${COMMON}/versioning -I${ROOT}/examiner -gnatf -k
GNATMAKE_OPTS:=${COMMON_OPTS} -O1
BIND_OPTS:=-E

################################################################################
# PLATFORM SPECIFIC CONFIGURATION
################################################################################

# Windows.
ifeq (${TARGET},Windows)
    EXE_EXTN:=.exe
    PREP_TARGET:=Intel_WinNT
endif

# Solaris.
ifeq (${TARGET},SunOS)
    EXE_EXTN:=
    PREP_TARGET:=SPARC_Solaris
endif

# Linux.
ifeq (${TARGET},Linux)
    EXE_EXTN:=
    PREP_TARGET:=Intel_Linux
endif

# Darwin (Mac OS X 10.5 or 10.6, 64-bit).
ifeq (${TARGET},Darwin)
    EXE_EXTN:=
    PREP_TARGET:=Darwin

    # The full-blown implementation of symbolic tracebacks is not
    # working on GNAT Pro at the moment, so
    # force local compilation of dummy GNAT.Traceback.Symbolic in
    # examiner/g-trasym.adb
    GNATMAKE_OPTS:=-a ${GNATMAKE_OPTS}
endif

################################################################################
# TARGETS
################################################################################

all: ${OUTPUT_NAME}${EXE_EXTN}

${OUTPUT_NAME}${EXE_EXTN}: preamble prep
	gnatmake ${GNATMAKE_OPTS} ${OUTPUT_NAME} -o ${OUTPUT_NAME}${EXE_EXTN} -bargs ${BIND_OPTS}

examine: preamble prep
	-spark -plain @${OUTPUT_NAME}.smf

preamble:
	make -C ${ROOT}/examiner clean

# Platform specific prepping
# ==========================

prep: ${PREP_TARGETS}
	make -C ${ROOT}/examiner prep

%.ads: %.aps
	gnatprep ${PREP_OPTS} -DTarget=${PREP_TARGET} $< $@

%.adb: %.apb
	gnatprep ${PREP_OPTS} -DTarget=${PREP_TARGET} $< $@

# Cleaning code base
# ==================

clean: residueclean standardclean

reallyclean: clean targetclean vcclean preamble
	make -C ${ROOT}/examiner reallyclean

residueclean:
	rm -f ${PREP_TARGETS}

standardclean:
	rm -f *.o *.ali

targetclean:
	rm -f ${OUTPUT_NAME}${EXE_EXTN}
	rm -f b~*.ad[sb]

vcclean:
	-find vcg -type f -name "*.vcg" -delete
	-find vcg -type f -name "*.fdl" -delete
	-find vcg -type f -name "*.rls" -delete
	-find vcg -type f -name "*.siv" -delete
	-find vcg -type f -name "*.slg" -delete
	-find vcg -type f -name "*.sli" -delete
	-find vcg -type f -name "*.lsb" -delete
	-find vcg -type f -name "*.log" -delete
	rm -f vcg/${OUTPUT_NAME}.rep
	-find vcg -depth -mindepth 1 -type d | grep -v -e '/\.svn' | xargs rmdir --ignore-fail-on-non-empty

################################################################################
# END-OF-FILE
