=== debian/changelog ===
spark (2010.0.deb-6) unstable; urgency=medium

  * Fix mistakes in the manpages
  * Build-depend and depend on swi-prolog-nox (>= 5.10.4~), this fixes
    breakage with new prolog version. Hopefully it can be replaced with
    something better in the future
  * Urgency medium to allow spark to migrate to testing at the same time
    as swi-prolog

 -- Євгеній Мещеряков <eugen@debian.org>  Sun, 19 Jun 2011 18:28:06 +0200

spark (2010.0.deb-5) unstable; urgency=low

  * Add parallel build support (only for gnatmake invocations)

 -- Євгеній Мещеряков <eugen@debian.org>  Sat, 04 Jun 2011 01:47:58 +0200

spark (2010.0.deb-4) unstable; urgency=low

  * Refresh checker-remove-close_all_streams.diff

 -- Євгеній Мещеряков <eugen@debian.org>  Fri, 03 Jun 2011 23:20:11 +0200

spark (2010.0.deb-3) unstable; urgency=low

  * Complete port of checker to SWI prolog and enable it
  * Fix defect detection functions in simplifier and fix remaining
    defects

 -- Євгеній Мещеряков <eugen@debian.org>  Fri, 03 Jun 2011 12:58:37 +0200

spark (2010.0.deb-2) unstable; urgency=low

  * Add Vcs-* fields to debian/control
  * New patches:
    - sparklarl-redundant-conversion.diff: remove reduntant conversions to
      File_Type. This causes warnings with gnat-4.6
    - examiner-useless-assignment.diff: remove useless assignment of a
      variable to itself
    - examiner-redundant-conversion.diff: remove redundant conversion to
      Integer
  * Standards-Version 3.9.2 — no changes required

 -- Євгеній Мещеряков <eugen@debian.org>  Mon, 02 May 2011 10:27:57 +0200

spark (2010.0.deb-1) unstable; urgency=low

  * Initial release (Closes: #617551)

 -- Євгеній Мещеряков <eugen@debian.org>  Sun, 27 Mar 2011 22:14:12 +0200
